"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var SessionLoginProvider_1 = require("./login/SessionLoginProvider");
var GithubProfileStatus = /** @class */ (function () {
    function GithubProfileStatus(options) {
        this.options = options;
        if (typeof options.session !== 'string') {
            throw new Error('You must provide a user session cookie');
        }
        this.loginProvider = new SessionLoginProvider_1.SessionLoginProvider(options.session);
    }
    /**
     * Gets the current user profile status
     */
    GithubProfileStatus.prototype.get = function () {
        return __awaiter(this, void 0, void 0, function () {
            var homePage, _a, emoji, message, busy, _b, emojiValue, messageValue, busyValue;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.loginProvider.login()];
                    case 1:
                        homePage = _c.sent();
                        return [4 /*yield*/, this.getFormFields(homePage)];
                    case 2:
                        _a = _c.sent(), emoji = _a.emoji, message = _a.message, busy = _a.busy;
                        return [4 /*yield*/, Promise.all([
                                this.getPropertyAsJSON(emoji, 'value'),
                                this.getPropertyAsJSON(message, 'value'),
                                this.getPropertyAsJSON(busy, 'checked'),
                            ])];
                    case 3:
                        _b = _c.sent(), emojiValue = _b[0], messageValue = _b[1], busyValue = _b[2];
                        return [4 /*yield*/, homePage.browser().close()];
                    case 4:
                        _c.sent();
                        return [2 /*return*/, {
                                busy: busyValue,
                                emoji: emojiValue,
                                message: messageValue,
                            }];
                }
            });
        });
    };
    /**
     * Sets the user profile status
     */
    GithubProfileStatus.prototype.set = function (status) {
        return __awaiter(this, void 0, void 0, function () {
            var homePage, fields;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loginProvider.login()];
                    case 1:
                        homePage = _a.sent();
                        return [4 /*yield*/, this.getFormFields(homePage)];
                    case 2:
                        fields = _a.sent();
                        if (!status.message) return [3 /*break*/, 4];
                        return [4 /*yield*/, homePage.evaluate(function (el, emoji) { return (el.value = emoji); }, fields.message, status.message)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        if (!status.emoji) return [3 /*break*/, 6];
                        return [4 /*yield*/, homePage.evaluate(function (el, emoji) { return (el.value = emoji); }, fields.emoji, status.emoji)];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        if (status.busy !== undefined) {
                            homePage.evaluate(function (el, isBusy) {
                                el.checked = isBusy;
                            }, fields.busy, status.busy);
                        }
                        return [4 /*yield*/, homePage.evaluate(function (el) { return el.submit(); }, fields.form)];
                    case 7:
                        _a.sent();
                        return [4 /*yield*/, homePage.waitForResponse(function (response) {
                                return response.url().includes('/users/status') && response.status() === 200;
                            })];
                    case 8:
                        _a.sent();
                        return [4 /*yield*/, homePage.browser().close()];
                    case 9:
                        _a.sent();
                        return [2 /*return*/, true];
                }
            });
        });
    };
    /**
     * Returns references for the element handlers of user profile status fields
     */
    GithubProfileStatus.prototype.getFormFields = function (page) {
        return __awaiter(this, void 0, void 0, function () {
            var form, _a, message, emoji, busy;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, page.$('form[action^="/users/status"]')];
                    case 1:
                        form = _b.sent();
                        if (!form) {
                            throw new Error('Could find status form');
                        }
                        return [4 /*yield*/, Promise.all([
                                form.$('input[name="message"]'),
                                form.$('input[name="emoji"]'),
                                form.$('input[name="limited_availability"]'),
                            ])];
                    case 2:
                        _a = _b.sent(), message = _a[0], emoji = _a[1], busy = _a[2];
                        if (!(message && emoji && busy)) {
                            throw new Error('Could not find status form inputs');
                        }
                        return [2 /*return*/, { busy: busy, emoji: emoji, form: form, message: message }];
                }
            });
        });
    };
    /**
     * Fetches a single property of an element handle as JSON
     */
    GithubProfileStatus.prototype.getPropertyAsJSON = function (element, propertyName) {
        return __awaiter(this, void 0, void 0, function () {
            var property;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, element.getProperty(propertyName)];
                    case 1:
                        property = _a.sent();
                        return [2 /*return*/, property.jsonValue()];
                }
            });
        });
    };
    return GithubProfileStatus;
}());
exports.GithubProfileStatus = GithubProfileStatus;
